golang 最和谐的子序列

We define a harmonious array is an array where the difference between its maximum value and its minimum value is exactly 1.

Now, given an integer array, you need to find the length of its longest harmonious subsequence among all its possible subsequences.

Example 1:

Input: [1,3,2,2,5,2,3,7]
Output: 5
Explanation: The longest harmonious subsequence is [3,2,2,2,3].

Note: The length of the input array will not exceed 20,000.

关于和谐子序列就是序列中数组的最大最小差值均为1。由于这里只是让我们求长度,并不需要返回具体的子序列。所以我们可以对数组进行排序,那么实际上我们只要找出来相差为1的两个数的总共出现个数就是一个和谐子序列的长度了。明白了这一点,我们就可以建立一个数字和其出现次数之间的映射,利用map的自动排序的特性,那么我们遍历map的时候就是从小往大开始遍历,我们从第二个映射对开始遍历,每次跟其前面的映射对比较,如果二者的数字刚好差1,那么就把二个数字的出现的次数相加并更新结果res即可,就是golang的实现方法,参考代码

func findLHS(nums []int) int {
    //给输入的数组排序
    numSlice := sort.IntSlice(nums)
    sort.Sort(numSlice)
    //map是无序的所以用slice来记住顺序的数字(已经去掉重复)
    var keySlice []int = make([]int, 0)
    var dic = make(map[int]int)
    for i := 0; i < len(numSlice); i++ {
        if _, ok := dic[numSlice[i]]; ok {
            dic[numSlice[i]] += 1
        } else {
            dic[numSlice[i]] = 1
            keySlice = append(keySlice, numSlice[i])
        }
    }
    var maxLength int
    for k, v := range keySlice {
        if k <= len(numSlice)-1 {
            if _, ok := dic[v+1]; ok {
                if maxLength < dic[v]+dic[v+1] {
                    maxLength = dic[v] + dic[v+1]
                }
            }
        }
    }
    return maxLength
}

  

时间: 2024-10-12 20:08:06

golang 最和谐的子序列的相关文章

594. Longest Harmonious Subsequence 最长的和谐子序列

Total Accepted: 5540 Total Submissions: 14066 Difficulty: Easy Contributors:love_Fawn We define a harmonious array is an array where the difference between its maximum value and its minimum value is exactly 1. Now, given an integer array, you need to

【leetcode 简单】 第一百四十六题 最长和谐子序列

和谐数组是指一个数组里元素的最大值和最小值之间的差别正好是1. 现在,给定一个整数数组,你需要在所有可能的子序列中找到最长的和谐子序列的长度. 示例 1: 输入: [1,3,2,2,5,2,3,7] 输出: 5 原因: 最长的和谐数组是:[3,2,2,2,3]. 说明: 输入的数组长度最大不超过20,000. from collections import Counter class Solution: def findLHS(self, nums): """ :type n

Leetcode 594.最长和谐子序列

最长和谐子序列 和谐数组是指一个数组里元素的最大值和最小值之间的差别正好是1. 现在,给定一个整数数组,你需要在所有可能的子序列中找到最长的和谐子序列的长度. 示例 1: 输入: [1,3,2,2,5,2,3,7] 输出: 5 原因: 最长的和谐数组是:[3,2,2,2,3]. 说明: 输入的数组长度最大不超过20,000. 思路: 将数组中的元素作为key,该元素出现次数作为value存入哈希表.遍历哈希表,找出最长和谐子序列. 1 import java.util.HashMap; 2 3

最长递增子序列-golang 实现

对于数组a = []int{3,1,2,8,9,5,6},最长递增子序列为:{1,2,8,9}或者{1,2,5,6}.建立数组dp,用来保存以数组a中元素结尾的递增子序列的最长长度,得到dp如下:dp = []int{1,1,2,3,4,3,4}其中dp的求解过程可以是: for key, val := range a{ maxLen := 1 for j := (key-1); j>=0; j-- { if a[j] < val && dp[j] >= maxLen{

最长公共子序列-golang

题目: 给定两个字符串str1和str2,返回两个字符串的最长公共子序列 举例: str1 = "1A2C3D4B56" str2 = "B1D23CA45B6A" 它们的最长公共子序列为:"123456" 或 "12C4B6" 解题方法: 经典的动态规划方法: 根据状态方程可以得到由str1和str2生成的状态数组dp,代码如下: func GetDp(arr1, arr2 []rune)[][]int{ dp := mak

[LeetCode] Longest Harmonious Subsequence 最长和谐子序列

We define a harmonious array is an array where the difference between its maximum value and its minimum value is exactly 1. Now, given an integer array, you need to find the length of its longest harmonious subsequence among all its possible subseque

leetcode 594最长和谐子序列

class Solution { public: int findLHS(vector<int>& nums) { int res=0; map<int,int> m; for(auto num:nums) ++m[num]; for(auto a:m){ if (m.count(a.first+1)){ res=max(res,m[a.first]+m[a.first+1]); } } return res; } }; 原文地址:https://www.cnblogs.c

golang基础数据结构

一.概述: 这里主要讨论四种类型---数组.slice.map和结构体 数组和结构体是聚合类型:它们的值都是由很多个元素或者成员字段的值组成.数组是有同构元素组成--每个数组的元素的类型相同:结构体为异构元素组成--每个结构体不一定是同类型元素构成:数组和结构体都是有固定内存大小的数据结构: slice和map则是动态的数据结构,它们需要动态增长: 需要注意的是函数中传递数组:一般而言,当调用函数时,函数的每个调用参数将会被赋值给函数内部的形式参数,所以函数参数接收的是一个复制的副本,而不是原始

用golang刷LeetCode

用golang刷LeetCode 用Go语言刷LeetCode记录,只是为了练习Go语言,能力有限不保证都是最优解,只能在此抛转引玉了. 数据结构和算法 数据结构和算法是程序员的命根子,没了命根子也就没有了尊严. 1. 两数之和 题目描述 力扣(LeetCode)链接 给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标. 你可以假设每种输入只会对应一个答案.但是,你不能重复利用这个数组中同样的元素. 示例: 给定 nums